{
   SpidAlfa
   (C) 2003 by Sebastian Stoff
   using sources from Jacek Bielecki / SPID ELEKTRONIK
         ComPort Library by Dejan Crnila

   This rotor driver is based on *My DDE Client*

   Application uses TComPort 2.64 components.

   --------------------------------------------------------------------

   My DDE Client is an example of user's custom driver for Orbitron.
   (C) 2003 by Sebastian Stoff
   sebastian@stoff.pl
   www.stoff.pl

   CHANGING, COMPILING AND FREE DISTRIBUTING OF THIS PROGRAM/SOURCES IS
   ALLOWED FOR ***ORBITRON*** RELATED PURPOSES WITHOUT MY PERMISSION.
}

unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DdeMan, StdCtrls, ExtCtrls, Buttons, CPortCtl, CPort, Registry, Math;

const doSTOP   = 1;
      doSTATE  = 2;
      doSET    = 3;
      cmdSTOP  : string[13] = #87#0#0#0#0#0#0#0#0#0#0#15#32;
      cmdSTATE : string[13] = #87#0#0#0#0#0#0#0#0#0#0#31#32;
      cmdSET   : string[13] = #87#0#0#0#0#0#0#0#0#0#0#47#32;

type
  TSatData = record
    name        : String;       //satellite name
    azm,elv     : Double;       //observation angles
    upf,dnf     : Double;       //uplink and downlink frequencies
    upm,dnm     : String;       //uplink and downlink modes
  end;
  TFMain = class(TForm)
    Tracking: TDdeClientConv;
    TrackingData: TDdeClientItem;
    Timer: TTimer;
    Label1: TLabel;
    l_st: TLabel;
    Label3: TLabel;
    l_dd: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Bevel1: TBevel;
    l_az: TLabel;
    l_el: TLabel;
    l_uf: TLabel;
    l_df: TLabel;
    l_um: TLabel;
    l_dm: TLabel;
    Bevel2: TBevel;
    l_na: TLabel;
    Label4: TLabel;
    CP: TComPort;
    CPP: TComComboBox;
    Label2: TLabel;
    Bevel3: TBevel;
    Image1: TImage;
    TimeOut: TTimer;
    l_cm: TLabel;
    Label14: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    s_az: TLabel;
    s_el: TLabel;
    s_ac: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    cs: TComboBox;
    op: TSpeedButton;
    SpeedButton4: TSpeedButton;
    s_te: TLabel;
    Label13: TLabel;
    Label15: TLabel;
    Label18: TLabel;
    s_dv: TLabel;
    Label20: TLabel;
    procedure TimerTimer(Sender: TObject);
    procedure TrackingOpen(Sender: TObject);
    procedure TrackingClose(Sender: TObject);
    procedure TrackingDataChange(Sender: TObject);
    procedure CPPChange(Sender: TObject);
    procedure TimeOutTimer(Sender: TObject);
    procedure CPRxChar(Sender: TObject; Count: Integer);
    procedure CPAfterOpen(Sender: TObject);
    procedure CPAfterClose(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpeedButton4Click(Sender: TObject);
    procedure opClick(Sender: TObject);
    procedure csChange(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ParseString(s: String; var data: TSatData);
    procedure PrintData(data: TSatData);

    procedure ReceivedStr;
    function SendToRotor(cmd:Byte;az,el: Double):Boolean;
  end;

var
  FMain         : TFMain;
  SatData       : TSatData;
  OldA,OldE     : Double;
  Received      : String;
  ComSeq        : Integer=0;
  WaitFor       : Integer=0;
  ErrorTO       : Boolean;
  DivH,cnt      : Integer;
  Reg           : TRegistry;
  PathP         : String;

implementation

{$R *.DFM}

procedure Replace(var s: String; subs1,subs2: String);
var i : Integer;
begin
  if subs1='' then Exit;
  if subs1=subs2 then Exit;
  i:=Pos(subs1,s);
  while i>0 do begin
    Delete(s,i,Length(subs1));
    Insert(subs2,s,i);
    i:=Pos(subs1,s);
  end;
end;

function FieldToReal(s: String):Real;
var c : Integer;
begin
  val(s,result,c);
  if c>0 then result:=0;
end;

function GetField(source,field: String):String;
var p1,p2  : Integer;
    quotes : Boolean;
    s2     : String;

  function FindField(source,field: String):Integer;
  var i      : Integer;
      quotes : Boolean;
  begin
    quotes:=False;
    for i:=1 to Length(source) do begin
      if source[i]='"' then begin
        quotes:=not quotes;
        Continue;
      end;

      if quotes then source[i]:='-';
    end;
    result:=pos(field,source);
  end;

begin
  source:=' '+source;
  field:=UpperCase(field);
  field:=' '+field;
  p1:=FindField(source,field);
  if p1=0 then begin
    result:='';
    Exit;
  end;

  s2:='';
  p2:=p1+3;
  quotes:=False;
  while p2<=Length(source) do begin
    if source[p2]='"' then begin
      quotes:=not quotes;
      Inc(p2);
      Continue;
    end;

    if (source[p2]=' ') and not quotes then Break;

    s2:=s2+source[p2];
    Inc(p2);
  end;
  result:=s2;
end;

procedure TFMain.ParseString(s: String; var data: TSatData);
begin
  if (s='') then with data do begin
    name:='?';
    azm:=0;
    elv:=0;
    upf:=0;
    dnf:=0;
    upm:='';
    dnm:='';
    Exit;
  end;

  s:=UpperCase(s);
  Replace(s,',','.');
  with data do begin
    name:=GetField(s,'SN');
    azm:=FieldToReal(GetField(s,'AZ'));
    elv:=FieldToReal(GetField(s,'EL'));
    upf:=FieldToReal(GetField(s,'UP'));
    dnf:=FieldToReal(GetField(s,'DN'));
    upm:=GetField(s,'UM');
    dnm:=GetField(s,'DM');
  end;
end;

procedure TFMain.PrintData(data: TSatData);
begin
  with data do begin
    l_na.Caption:=name;
    l_az.Caption:=FloatToStrF(azm,ffFixed,4,1);
    l_el.Caption:=FloatToStrF(elv,ffFixed,4,1);
    l_uf.Caption:=FloatToStrF(upf,ffFixed,12,0)+' Hz';
    l_df.Caption:=FloatToStrF(dnf,ffFixed,12,0)+' Hz';
    l_um.Caption:=upm;
    l_dm.Caption:=dnm;
  end;
end;

procedure TFMain.TimerTimer(Sender: TObject);
begin
  inc(cnt);
  case cnt of
    1 : SendToRotor(doSTATE,0,0);
    2 : if WaitFor=0 then begin
          if ((OldA<>SatData.azm) or (OldE<>SatData.elv)) and (SatData.name<>'?') then
            SendToRotor(doSET,SatData.azm,Max(0,SatData.elv));
        end else dec(cnt);
  end;
  case ComSeq of
    0 : if cnt>=6 then cnt:=0;
    1 : if cnt>=3 then cnt:=0;
  end;
end;


procedure TFMain.TimeOutTimer(Sender: TObject);
begin
  ErrorTO:=True;
  WaitFor:=0;
  TimeOut.Enabled:=False;
  Received:='';
end;

procedure TFMain.TrackingOpen(Sender: TObject);
begin
  l_dd.Caption:='Opened';
end;

procedure TFMain.TrackingClose(Sender: TObject);
begin
  l_dd.Caption:='Closed';
  l_st.Caption:='No data';
  ParseString('',SatData);
  PrintData(SatData);
end;

procedure TFMain.TrackingDataChange(Sender: TObject);
var s : String;
begin
  s:=Trim(TrackingData.Text);
  if s='' then l_st.Caption:='No data' else
    l_st.Caption:=s;
  ParseString(s,SatData);
  PrintData(SatData);
end;

procedure TFMain.CPPChange(Sender: TObject);
begin
  try
    if CP.Connected then CP.Close;
    CP.Port:=CPP.Text;
    if op.down then CP.Open;
  except
    op.Down:=False;
  end;
end;

function TFMain.SendToRotor(cmd:Byte;az,el: Double):Boolean;
var k : Integer;
begin
  result:=False;
  if not CP.Connected then Exit;
  case cmd of
    1 : begin                   //Stop
          l_cm.Caption:='STOP';
          OldA:=999;

          WaitFor:=12;
          ErrorTO:=False;
          TimeOut.Enabled:=True;
            cp.WriteStr(cmdSTOP);
          while WaitFor>0 do Application.ProcessMessages;
          if not op.Down then Exit;
          s_te.Visible:=ErrorTO;
          if ErrorTO then Exit;

          ReceivedStr;
        end;
    2 : begin                   //State
          l_cm.Caption:='STATE';

          WaitFor:=12;
          ErrorTO:=False;
          TimeOut.Enabled:=True;
            cp.WriteStr(cmdSTATE);
          while WaitFor>0 do Application.ProcessMessages;
          if not op.Down then Exit;
          s_te.Visible:=ErrorTO;
          result:=ErrorTO;
          if ErrorTO then Exit;

          ReceivedStr;
        end;
    3 : begin                   //Set
          l_cm.Caption:='SET('+FloatToStrF(az,ffFixed,5,1)+';'+FloatToStrF(el,ffFixed,5,1)+')';

          k := Trunc((az + 360) * divh);
          cmdSET[2] := chr(k div 1000+48); k := k mod 1000;
          cmdSET[3] := chr(k div 100+48);  k := k mod 100;
          cmdSET[4] := chr(k div 10+48);   k := k mod 10;
          cmdSET[5] := chr(k+48);

          k := Trunc((el + 360) * divh);
          cmdSET[7] := chr(k div 1000+48); k := k mod 1000;
          cmdSET[8] := chr(k div 100+48);  k := k mod 100;
          cmdSET[9] := chr(k div 10+48);   k := k mod 10;
          cmdSET[10]:= chr(k+48);

          OldA:=az;  OldE:=el;
          CP.WriteStr(cmdSET);
        end;
  end;
end;

procedure TFMain.ReceivedStr;
var k : double;
begin
  k := 100 * ord(Received[2]) +
        10 * ord(Received[3]) +
             ord(Received[4]) +
             ord(Received[5])/10;
  if k >= 360 then begin
    if k<720 then begin
      k := k-360;
      s_az.Font.Color := clBlue;
    end else begin
      k := k - 720;
      s_az.Font.Color := clRed;
    end;
  end else s_az.Font.Color := clRed;
  s_az.Caption:=FloatToStrF(k,ffFixed,5,1);

  divh := ord(Received[6]);
  s_dv.Caption:=IntToStr(divh);

  k := 100 * ord(Received[7]) +
        10 * ord(Received[8]) +
             ord(Received[9]) +
             ord(Received[10])/10;
  k := k-360;
  if k < 0 then s_el.Font.Color := clRed
  else s_el.Font.Color := clBlue;
  s_el.Caption:=FloatToStrF(k,ffFixed,5,1);
end;

procedure TFMain.CPRxChar(Sender: TObject; Count: Integer);
var s: string;
begin
  TimeOut.Enabled:=False;
  if WaitFor<=0 then begin
    CP.ReadStr(s,Count);
    Exit;
  end;

  if WaitFor<=Count then begin
    CP.ReadStr(Received,WaitFor);
    WaitFor:=0;
  end else TimeOut.Enabled:=true;
end;

procedure TFMain.CPAfterOpen(Sender: TObject);
begin
  s_te.Visible:=False;
  cnt:=0;
  OldA:=999;
  s_ac.Caption:='Opened';
  Timer.Enabled:=True;
end;

procedure TFMain.CPAfterClose(Sender: TObject);
begin
  Timer.Enabled:=False;
  if FMain.Visible then s_te.Visible:=False;
  l_cm.Caption:='';
  s_ac.Caption:='Closed';
end;

procedure TFMain.FormActivate(Sender: TObject);
begin
  try
    CP.Port:=CPP.Text;
    CP.Open;
  except
    op.Down:=False;
  end;
end;

procedure TFMain.FormCreate(Sender: TObject);
var s : String;
begin
  ParseString('',SatData);
  PrintData(SatData);

  PathP:=ExtractFileDir(ParamStr(0));
  if PathP[length(PathP)]<>'\' then PathP:=PathP+'\';
  ChDir(PathP);

  Reg:=TRegistry.Create;
  try
    if Reg.OpenKey('\Software\Stoff\Orbitron\SpidAlfa',True) then begin
      s:=Reg.ReadString('ComPort');
      if CPP.Items.IndexOf(s)>=0 then CPP.Text:=s;
      s:=Reg.ReadString('ComSeq');
      ComSeq:=Max(0,cs.Items.IndexOf(s));
      cs.ItemIndex:=ComSeq;
    end;
    If not FileExists(PathP+'Orbitron.exe') then
      if Reg.OpenKey('\Software\Stoff\Orbitron',True) then
        Tracking.ServiceApplication:=Reg.ReadString('Path')+'orbitron';
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
  Tracking.OpenLink;
  divh:=1;
end;

procedure TFMain.SpeedButton1Click(Sender: TObject);
begin
  FMain.Close;
end;

procedure TFMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  Timer.Enabled:=False;

  Reg:=TRegistry.Create;
  try
    if Reg.OpenKey('\Software\Stoff\Orbitron\SpidAlfa',True) then begin
      Reg.WriteString('ComPort',CPP.Text);
      Reg.WriteString('ComSeq',cs.Text);
    end
  finally
    Reg.CloseKey;
    Reg.Free;
  end;

  Tracking.CloseLink;
  while WaitFor<>0 do Application.ProcessMessages;
  SendToRotor(doSTOP,0,0);
end;

procedure TFMain.SpeedButton4Click(Sender: TObject);
begin
  FMain.Close;
end;

procedure TFMain.opClick(Sender: TObject);
begin
  if CP.Connected=op.Down then begin
    op.Down:=not op.Down;
    Exit;
  end;
  try
    case op.Down of
      false : begin
                while WaitFor<>0 do Application.ProcessMessages;
                SendToRotor(doSTOP,0,0);
                CP.Close;
              end;
      true  : CP.Open;
    end;
  except
    op.Down:=False;
  end;
end;

procedure TFMain.csChange(Sender: TObject);
begin
  ComSeq:=cs.ItemIndex;
end;

procedure TFMain.Image1Click(Sender: TObject);
begin
  Tracking.OpenLink;
end;

end.

